package com.persagy.dmp.report.controller;

import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.report.common.criteria.JacksonCriteria;
import com.persagy.dmp.report.entity.ReportConfig;
import com.persagy.dmp.report.service.ReportConfigService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/report/config")
public class ReportConfigController {

    @Autowired
    private ReportConfigService service;

    @PostMapping("/query")
    public PagedResponse<ReportConfig> query(@RequestBody JacksonCriteria criteria) {
        return service.query(criteria);
    }

    @PostMapping("/create")
    public MapResponse create(@RequestBody ReportConfig param) {
        return service.create(param);
    }

    @PostMapping("/update")
    public MapResponse update(@RequestBody ReportConfig param) {
        return service.update(param);
    }

    @PostMapping("/delete")
    public MapResponse delete(@RequestBody ReportConfig param) {
        return service.delete(param);
    }

    @GetMapping("/groupbyColumns")
    public MapResponse groupbyColumns(@RequestParam String tableName) {
        return service.groupbyColumns(tableName);
    }

    @GetMapping("/calculated")
    public MapResponse calculated(@RequestParam String tableName) {
        return service.calculated(tableName);
    }
}
