package com.persagy.dmp.report.repository;

import com.persagy.dmp.report.entity.ReportConfig;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.querydsl.QuerydslPredicateExecutor;

import java.util.List;

public interface ReportConfigRepository extends JpaRepository<ReportConfig, String>, QuerydslPredicateExecutor<ReportConfig> {

    @Query(nativeQuery = true,
            value = "SELECT GROUP_CONCAT(DISTINCT group_column, ',') FROM report_config where table_name = ?")
    String groupbyColumns(String tableName);

    @Query(nativeQuery = true,
            value = "SELECT calculated FROM dmp_report.report_config where table_name = ?")
    List<String> calculated(String tableName);
}

